;;;
;;; Copyright (C) 2010 Frederic Vecoven
;;;
;;; This file is part of NixieClock
;;;
;;; NixieClock is free software; you can redistribute it and/or modify
;;; it under the terms of the GNU General Public License as published by
;;; the Free Software Foundation; either version 3 of the License, or
;;; (at your option) any later version.
;;;
;;; NixieClock is distributed in the hope that it will be useful,
;;; but WITHOUT ANY WARRANTY; without even the implied warranty of
;;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;; GNU General Public License for more details.
;;;
;;; You should have received a copy of the GNU General Public License
;;; along with this program. If not, see <http://www.gnu.org/licenses/>.
;;;
	
; 
; Effect macros
;


;
; set HH to a pair of tube (1,2,3). time = 0 (current time) or 1 (time+1sec)
;
M_HH	MACRO	pair, time
	if (pair == 1)
		if (time == 0)
			TUBE_VALUE	TUBE_1, AUTO, HOURS_H
			TUBE_VALUE	TUBE_2, AUTO, HOURS_L
		else
			TUBE_VALUE	TUBE_1, AUTO, HOURS_1_H
			TUBE_VALUE	TUBE_2, AUTO, HOURS_1_L
		endif
	else 
	if (pair == 2)
		if (time == 0)
			TUBE_VALUE	TUBE_3, AUTO, HOURS_H
			TUBE_VALUE	TUBE_4, AUTO, HOURS_L
		else
			TUBE_VALUE	TUBE_3, AUTO, HOURS_1_H
			TUBE_VALUE	TUBE_4, AUTO, HOURS_1_L
		endif
	else 
	if (pair == 3)
		if (time == 0)
			TUBE_VALUE	TUBE_5, AUTO, HOURS_H
			TUBE_VALUE	TUBE_6, AUTO, HOURS_L
		else
			TUBE_VALUE	TUBE_5, AUTO, HOURS_1_H
			TUBE_VALUE	TUBE_6, AUTO, HOURS_1_L
		endif
	else
		error "Invalid where value in M_HH macro"
	endif
	endif
	endif
	ENDM

M_MM	MACRO	pair, time
	if (pair == 1)
		if (time == 0)
			TUBE_VALUE	TUBE_1, AUTO, MINUTES_H
			TUBE_VALUE	TUBE_2, AUTO, MINUTES_L
		else
			TUBE_VALUE	TUBE_1, AUTO, MINUTES_1_H
			TUBE_VALUE	TUBE_2, AUTO, MINUTES_1_L
		endif
	else 
	if (pair == 2)
		if (time == 0)
			TUBE_VALUE	TUBE_3, AUTO, MINUTES_H
			TUBE_VALUE	TUBE_4, AUTO, MINUTES_L
		else
			TUBE_VALUE	TUBE_3, AUTO, MINUTES_1_H
			TUBE_VALUE	TUBE_4, AUTO, MINUTES_1_L
		endif
	else 
	if (pair == 3)
		if (time == 0)
			TUBE_VALUE	TUBE_5, AUTO, MINUTES_H
			TUBE_VALUE	TUBE_6, AUTO, MINUTES_L
		else
			TUBE_VALUE	TUBE_5, AUTO, MINUTES_1_H
			TUBE_VALUE	TUBE_6, AUTO, MINUTES_1_L
		endif
	else
		error "Invalid where value in M_MM macro"
	endif
	endif
	endif
	ENDM

M_SS	MACRO	pair, time
	if (pair == 1)
		if (time == 0)
			TUBE_VALUE	TUBE_1, AUTO, SECONDS_H
			TUBE_VALUE	TUBE_2, AUTO, SECONDS_L
		else
			TUBE_VALUE	TUBE_1, AUTO, SECONDS_1_H
			TUBE_VALUE	TUBE_2, AUTO, SECONDS_1_L
		endif
	else 
	if (pair == 2)
		if (time == 0)
			TUBE_VALUE	TUBE_3, AUTO, SECONDS_H
			TUBE_VALUE	TUBE_4, AUTO, SECONDS_L
		else
			TUBE_VALUE	TUBE_3, AUTO, SECONDS_1_H
			TUBE_VALUE	TUBE_4, AUTO, SECONDS_1_L
		endif
	else 
	if (pair == 3)
		if (time == 0)
			TUBE_VALUE	TUBE_5, AUTO, SECONDS_H
			TUBE_VALUE	TUBE_6, AUTO, SECONDS_L
		else
			TUBE_VALUE	TUBE_5, AUTO, SECONDS_1_H
			TUBE_VALUE	TUBE_6, AUTO, SECONDS_1_L
		endif
	else
		error "Invalid where value in M_SS macro"
	endif
	endif
	endif
	ENDM
	

M_HH_ALT	MACRO	pair, time
	if (pair == 1)
		if (time == 0)
			TUBE_VALUE	TUBE_1_ALT, AUTO, HOURS_H
			TUBE_VALUE	TUBE_2_ALT, AUTO, HOURS_L
		else
			TUBE_VALUE	TUBE_1_ALT, AUTO, HOURS_1_H
			TUBE_VALUE	TUBE_2_ALT, AUTO, HOURS_1_L
		endif
	else 
	if (pair == 2)
		if (time == 0)
			TUBE_VALUE	TUBE_3_ALT, AUTO, HOURS_H
			TUBE_VALUE	TUBE_4_ALT, AUTO, HOURS_L
		else
			TUBE_VALUE	TUBE_3_ALT, AUTO, HOURS_1_H
			TUBE_VALUE	TUBE_4_ALT, AUTO, HOURS_1_L
		endif
	else 
	if (pair == 3)
		if (time == 0)
			TUBE_VALUE	TUBE_5_ALT, AUTO, HOURS_H
			TUBE_VALUE	TUBE_6_ALT, AUTO, HOURS_L
		else
			TUBE_VALUE	TUBE_5_ALT, AUTO, HOURS_1_H
			TUBE_VALUE	TUBE_6_ALT, AUTO, HOURS_1_L
		endif
	else
		error "Invalid where value in M_HH_ALT macro"
	endif
	endif
	endif
	ENDM

M_MM_ALT	MACRO	pair, time
	if (pair == 1)
		if (time == 0)
			TUBE_VALUE	TUBE_1_ALT, AUTO, MINUTES_H
			TUBE_VALUE	TUBE_2_ALT, AUTO, MINUTES_L
		else
			TUBE_VALUE	TUBE_1_ALT, AUTO, MINUTES_1_H
			TUBE_VALUE	TUBE_2_ALT, AUTO, MINUTES_1_L
		endif
	else 
	if (pair == 2)
		if (time == 0)
			TUBE_VALUE	TUBE_3_ALT, AUTO, MINUTES_H
			TUBE_VALUE	TUBE_4_ALT, AUTO, MINUTES_L
		else
			TUBE_VALUE	TUBE_3_ALT, AUTO, MINUTES_1_H
			TUBE_VALUE	TUBE_4_ALT, AUTO, MINUTES_1_L
		endif
	else 
	if (pair == 3)
		if (time == 0)
			TUBE_VALUE	TUBE_5_ALT, AUTO, MINUTES_H
			TUBE_VALUE	TUBE_6_ALT, AUTO, MINUTES_L
		else
			TUBE_VALUE	TUBE_5_ALT, AUTO, MINUTES_1_H
			TUBE_VALUE	TUBE_6_ALT, AUTO, MINUTES_1_L
		endif
	else
		error "Invalid where value in M_MM_ALT macro"
	endif
	endif
	endif
	ENDM

M_SS_ALT	MACRO	pair, time
	if (pair == 1)
		if (time == 0)
			TUBE_VALUE	TUBE_1_ALT, AUTO, SECONDS_H
			TUBE_VALUE	TUBE_2_ALT, AUTO, SECONDS_L
		else
			TUBE_VALUE	TUBE_1_ALT, AUTO, SECONDS_1_H
			TUBE_VALUE	TUBE_2_ALT, AUTO, SECONDS_1_L
		endif
	else 
	if (pair == 2)
		if (time == 0)
			TUBE_VALUE	TUBE_3_ALT, AUTO, SECONDS_H
			TUBE_VALUE	TUBE_4_ALT, AUTO, SECONDS_L
		else
			TUBE_VALUE	TUBE_3_ALT, AUTO, SECONDS_1_H
			TUBE_VALUE	TUBE_4_ALT, AUTO, SECONDS_1_L
		endif
	else 
	if (pair == 3)
		if (time == 0)
			TUBE_VALUE	TUBE_5_ALT, AUTO, SECONDS_H
			TUBE_VALUE	TUBE_6_ALT, AUTO, SECONDS_L
		else
			TUBE_VALUE	TUBE_5_ALT, AUTO, SECONDS_1_H
			TUBE_VALUE	TUBE_6_ALT, AUTO, SECONDS_1_L
		endif
	else
		error "Invalid where value in M_SS_ALT macro"
	endif
	endif
	endif
	ENDM
	

;
; set HHMM   'alt' selects TUBE or TUBE_ALT, 'time' select +0 or +1sec time
;
HHMM	MACRO	alt, time
	if (alt == 0)
		M_HH	1, time
		M_MM	2, time
	else
		M_HH_ALT 1, time
		M_MM_ALT 2, time
	endif
	ENDM

;
; set HHMM   'alt' selects TUBE or TUBE_ALT, 'time' select +0 or +1sec time
;	
HHMMSS	MACRO	alt, time
	if (alt == 0)
		M_HH	1, time
		M_MM	2, time
		M_SS	3, time
		;TUBE_DP	TUBE_2 | TUBE_4, DIRECT, DP_OFF
	else
		M_HH_ALT 1, time
		M_MM_ALT 2, time
		M_SS_ALT 3, time
	endif
	ENDM

	


;
; set date part 1 to a pair of tube (1,2,3). time = 0 (current time) or 1 (time+1sec)
;
M_DA1	MACRO	pair, time
	if (pair == 1)
		if (time == 0)
			TUBE_VALUE	TUBE_1, AUTO, DATE_PART1_H
			TUBE_VALUE	TUBE_2, AUTO, DATE_PART1_L
		else
			TUBE_VALUE	TUBE_1, AUTO, DATE_PART1_1_H
			TUBE_VALUE	TUBE_2, AUTO, DATE_PART1_1_L
		endif
	else 
	if (pair == 2)
		if (time == 0)
			TUBE_VALUE	TUBE_3, AUTO, DATE_PART1_H
			TUBE_VALUE	TUBE_4, AUTO, DATE_PART1_L
		else
			TUBE_VALUE	TUBE_3, AUTO, DATE_PART1_1_H
			TUBE_VALUE	TUBE_4, AUTO, DATE_PART1_1_L
		endif
	else 
	if (pair == 3)
		if (time == 0)
			TUBE_VALUE	TUBE_5, AUTO, DATE_PART1_H
			TUBE_VALUE	TUBE_6, AUTO, DATE_PART1_L
		else
			TUBE_VALUE	TUBE_5, AUTO, DATE_PART1_1_H
			TUBE_VALUE	TUBE_6, AUTO, DATE_PART1_1_L
		endif
	else
		error "Invalid where value in M_DA1 macro"
	endif
	endif
	endif
	ENDM

M_DA2	MACRO	pair, time
	if (pair == 1)
		if (time == 0)
			TUBE_VALUE	TUBE_1, AUTO, DATE_PART2_H
			TUBE_VALUE	TUBE_2, AUTO, DATE_PART2_L
		else
			TUBE_VALUE	TUBE_1, AUTO, DATE_PART2_1_H
			TUBE_VALUE	TUBE_2, AUTO, DATE_PART2_1_L
		endif
	else 
	if (pair == 2)
		if (time == 0)
			TUBE_VALUE	TUBE_3, AUTO, DATE_PART2_H
			TUBE_VALUE	TUBE_4, AUTO, DATE_PART2_L
		else
			TUBE_VALUE	TUBE_3, AUTO, DATE_PART2_1_H
			TUBE_VALUE	TUBE_4, AUTO, DATE_PART2_1_L
		endif
	else 
	if (pair == 3)
		if (time == 0)
			TUBE_VALUE	TUBE_5, AUTO, DATE_PART2_H
			TUBE_VALUE	TUBE_6, AUTO, DATE_PART2_L
		else
			TUBE_VALUE	TUBE_5, AUTO, DATE_PART2_1_H
			TUBE_VALUE	TUBE_6, AUTO, DATE_PART2_1_L
		endif
	else
		error "Invalid where value in M_DA2 macro"
	endif
	endif
	endif
	ENDM	

M_YY	MACRO	pair, time
	if (pair == 1)
		if (time == 0)
			TUBE_VALUE	TUBE_1, AUTO, YEAR_H
			TUBE_VALUE	TUBE_2, AUTO, YEAR_L
		else
			TUBE_VALUE	TUBE_1, AUTO, YEAR_1_H
			TUBE_VALUE	TUBE_2, AUTO, YEAR_1_L
		endif
	else 
	if (pair == 2)
		if (time == 0)
			TUBE_VALUE	TUBE_3, AUTO, YEAR_H
			TUBE_VALUE	TUBE_4, AUTO, YEAR_L
		else
			TUBE_VALUE	TUBE_3, AUTO, YEAR_1_H
			TUBE_VALUE	TUBE_4, AUTO, YEAR_1_L
		endif
	else 
	if (pair == 3)
		if (time == 0)
			TUBE_VALUE	TUBE_5, AUTO, YEAR_H
			TUBE_VALUE	TUBE_6, AUTO, YEAR_L
		else
			TUBE_VALUE	TUBE_5, AUTO, YEAR_1_H
			TUBE_VALUE	TUBE_6, AUTO, YEAR_1_L
		endif
	else
		error "Invalid where value in M_YY macro"
	endif
	endif
	endif
	ENDM

	
M_DA1_ALT	MACRO	pair, time
	if (pair == 1)
		if (time == 0)
			TUBE_VALUE	TUBE_1_ALT, AUTO, DATE_PART1_H
			TUBE_VALUE	TUBE_2_ALT, AUTO, DATE_PART1_L
		else
			TUBE_VALUE	TUBE_1_ALT, AUTO, DATE_PART1_1_H
			TUBE_VALUE	TUBE_2_ALT, AUTO, DATE_PART1_1_L
		endif
	else 
	if (pair == 2)
		if (time == 0)
			TUBE_VALUE	TUBE_3_ALT, AUTO, DATE_PART1_H
			TUBE_VALUE	TUBE_4_ALT, AUTO, DATE_PART1_L
		else
			TUBE_VALUE	TUBE_3_ALT, AUTO, DATE_PART1_1_H
			TUBE_VALUE	TUBE_4_ALT, AUTO, DATE_PART1_1_L
		endif
	else 
	if (pair == 3)
		if (time == 0)
			TUBE_VALUE	TUBE_5_ALT, AUTO, DATE_PART1_H
			TUBE_VALUE	TUBE_6_ALT, AUTO, DATE_PART1_L
		else
			TUBE_VALUE	TUBE_5_ALT, AUTO, DATE_PART1_1_H
			TUBE_VALUE	TUBE_6_ALT, AUTO, DATE_PART1_1_L
		endif
	else
		error "Invalid where value in M_DA1_ALT macro"
	endif
	endif
	endif
	ENDM

M_DA2_ALT	MACRO	pair, time
	if (pair == 1)
		if (time == 0)
			TUBE_VALUE	TUBE_1_ALT, AUTO, DATE_PART2_H
			TUBE_VALUE	TUBE_2_ALT, AUTO, DATE_PART2_L
		else
			TUBE_VALUE	TUBE_1_ALT, AUTO, DATE_PART2_1_H
			TUBE_VALUE	TUBE_2_ALT, AUTO, DATE_PART2_1_L
		endif
	else 
	if (pair == 2)
		if (time == 0)
			TUBE_VALUE	TUBE_3_ALT, AUTO, DATE_PART2_H
			TUBE_VALUE	TUBE_4_ALT, AUTO, DATE_PART2_L
		else
			TUBE_VALUE	TUBE_3_ALT, AUTO, DATE_PART2_1_H
			TUBE_VALUE	TUBE_4_ALT, AUTO, DATE_PART2_1_L
		endif
	else 
	if (pair == 3)
		if (time == 0)
			TUBE_VALUE	TUBE_5_ALT, AUTO, DATE_PART2_H
			TUBE_VALUE	TUBE_6_ALT, AUTO, DATE_PART2_L
		else
			TUBE_VALUE	TUBE_5_ALT, AUTO, DATE_PART2_1_H
			TUBE_VALUE	TUBE_6_ALT, AUTO, DATE_PART2_1_L
		endif
	else
		error "Invalid where value in M_DA2_ALT macro"
	endif
	endif
	endif
	ENDM


M_YY_ALT	MACRO	pair, time
	if (pair == 1)
		if (time == 0)
			TUBE_VALUE	TUBE_1_ALT, AUTO, YEAR_H
			TUBE_VALUE	TUBE_2_ALT, AUTO, YEAR_L
		else
			TUBE_VALUE	TUBE_1_ALT, AUTO, YEAR_1_H
			TUBE_VALUE	TUBE_2_ALT, AUTO, YEAR_1_L
		endif
	else 
	if (pair == 2)
		if (time == 0)
			TUBE_VALUE	TUBE_3_ALT, AUTO, YEAR_H
			TUBE_VALUE	TUBE_4_ALT, AUTO, YEAR_L
		else
			TUBE_VALUE	TUBE_3_ALT, AUTO, YEAR_1_H
			TUBE_VALUE	TUBE_4_ALT, AUTO, YEAR_1_L
		endif
	else 
	if (pair == 3)
		if (time == 0)
			TUBE_VALUE	TUBE_5_ALT, AUTO, YEAR_H
			TUBE_VALUE	TUBE_6_ALT, AUTO, YEAR_L
		else
			TUBE_VALUE	TUBE_5_ALT, AUTO, YEAR_1_H
			TUBE_VALUE	TUBE_6_ALT, AUTO, YEAR_1_L
		endif
	else
		error "Invalid where value in M_YY_ALT macro"
	endif
	endif
	endif
	ENDM


	
;
; MACRO to set tubes to DD/MM (or MM/DD)
;
DDMM	MACRO	alt, time
	if (alt == 0)
		M_DA1	1, time
		M_DA2	2, time
	else
		M_DA1_ALT 1, time
		M_DA2_ALT 2, time
	endif
	ENDM

DDMMYY	MACRO	alt, time
	if (alt == 0)
		M_DA1	1, time
		M_DA2	2, time
		M_YY	3, time
		;TUBE_DP	TUBE_2 | TUBE_4, DIRECT, DP_ON
	else
		M_DA1_ALT 1, time
		M_DA2_ALT 2, time
		M_YY_ALT  3, time
	endif
	ENDM




;
; Transition to date (duration = 1s)
;
TO_DATE MACRO when, fading_speed
	ACTION_QSEC	(when)
	TUBE_FADING	TUBE_ALL, FADING, fading_speed
	DDMMYY	1, 0
	END_ACTION
	ACTION_QSEC	((when) + 4)
	DDMMYY	0, 0
	DDMMYY	1, 1
	END_ACTION
	ENDM
	
;
; Transition to time (duration = 1s)
;
TO_TIME MACRO when, fading_speed
	ACTION_QSEC	(when)
	TUBE_FADING	TUBE_ALL, FADING, fading_speed
	HHMMSS	1, 0
	END_ACTION
	ACTION_QSEC	((when) + 4)
	HHMMSS	0, 0
	HHMMSS	1, 1
	END_ACTION
	ENDM
	
;
; Empty display to the left (duration = N_TUBES * delta)
;
EMPTY_LEFT MACRO when, delta
#if NUM_TUBES == 4
	ACTION_QSEC	(when)
	ROTATE	LEFT
	TUBE_VALUE	TUBE_44, DIRECT, 0xA
	END_ACTION
	ACTION_QSEC	(when) + delta
	ROTATE	LEFT
	TUBE_VALUE	TUBE_44, DIRECT, 0xA
	END_ACTION
	ACTION_QSEC	(when) + 2 * delta
	ROTATE	LEFT
	TUBE_VALUE	TUBE_44, DIRECT, 0xA
	END_ACTION
	ACTION_QSEC	(when) + 3 * delta
	ROTATE	LEFT
	TUBE_VALUE	TUBE_44, DIRECT, 0xA
	END_ACTION
#else
	ACTION_QSEC	(when)
	ROTATE	LEFT
	TUBE_VALUE	TUBE_66, DIRECT, 0xA
	END_ACTION
	ACTION_QSEC	(when) + delta
	ROTATE	LEFT
	TUBE_VALUE	TUBE_66, DIRECT, 0xA
	END_ACTION
	ACTION_QSEC	(when) + 2 * delta
	ROTATE	LEFT
	TUBE_VALUE	TUBE_66, DIRECT, 0xA
	END_ACTION
	ACTION_QSEC	(when) + 3 * delta
	ROTATE	LEFT
	TUBE_VALUE	TUBE_66, DIRECT, 0xA
	END_ACTION
	ACTION_QSEC	(when) + 4 * delta
	ROTATE	LEFT
	TUBE_VALUE	TUBE_66, DIRECT, 0xA
	END_ACTION
	ACTION_QSEC	(when) + 5 * delta
	ROTATE	LEFT
	TUBE_VALUE	TUBE_66, DIRECT, 0xA
	END_ACTION
#endif	
	ENDM
	
;
; Empty display to the right (duration = N_TUBES * delta)
EMPTY_RIGHT MACRO when, delta
	ACTION_QSEC	(when)
	ROTATE	RIGHT
	TUBE_VALUE	TUBE_11, DIRECT, 0xA
	END_ACTION
	ACTION_QSEC	(when) + delta
	ROTATE	RIGHT
	TUBE_VALUE	TUBE_11, DIRECT, 0xA
	END_ACTION
	ACTION_QSEC	(when) + 2 * delta
	ROTATE	RIGHT
	TUBE_VALUE	TUBE_11, DIRECT, 0xA
	END_ACTION
	ACTION_QSEC	(when) + 3 * delta
	ROTATE	RIGHT
	TUBE_VALUE	TUBE_11, DIRECT, 0xA
	END_ACTION
#if NUM_TUBES == 6
	ACTION_QSEC	(when) + 4 * delta
	ROTATE	RIGHT
	TUBE_VALUE	TUBE_11, DIRECT, 0xA
	END_ACTION
	ACTION_QSEC	(when) + 5 * delta
	ROTATE	RIGHT
	TUBE_VALUE	TUBE_11, DIRECT, 0xA
	END_ACTION
#endif
	ENDM
	
	
;
; Shift time from the left (duration = N_TUBES * delta)
;
SHIFT_TIME_LEFT MACRO when, delta
#if NUM_TUBES == 4
	ACTION_QSEC	(when)
	ROTATE	RIGHT
	TUBE_VALUE	TUBE_1, AUTO, MINUTES_L
	TUBE_VALUE	TUBE_1_ALT, AUTO, MINUTES_1_L
	END_ACTION
	ACTION_QSEC	(when) + delta
	ROTATE	RIGHT
	TUBE_VALUE	TUBE_1, AUTO, MINUTES_H
	TUBE_VALUE	TUBE_1_ALT, AUTO, MINUTES_1_H
	END_ACTION	
	ACTION_QSEC	(when) + 2 * delta
	ROTATE	RIGHT
	TUBE_VALUE	TUBE_1, AUTO, HOURS_L
	TUBE_VALUE	TUBE_1_ALT, AUTO, HOURS_1_L
	END_ACTION
	ACTION_QSEC	(when) + 3 * delta
	ROTATE	RIGHT
	TUBE_VALUE	TUBE_1, AUTO, HOURS_H
	TUBE_VALUE	TUBE_1_ALT, AUTO, HOURS_1_H
	END_ACTION
#else
	ACTION_QSEC	(when)
	TUBE_VALUE	TUBE_1, AUTO, SECONDS_L
	TUBE_VALUE	TUBE_1_ALT, AUTO, SECONDS_1_L
	END_ACTION
	ACTION_QSEC	(when) + delta
	ROTATE	RIGHT
	TUBE_VALUE	TUBE_1, AUTO, SECONDS_H
	TUBE_VALUE	TUBE_1_ALT, AUTO, SECONDS_1_H
	END_ACTION
	ACTION_QSEC	(when) + 2 * delta
	ROTATE	RIGHT
	TUBE_VALUE	TUBE_1, AUTO, MINUTES_L
	TUBE_VALUE	TUBE_1_ALT, AUTO, MINUTES_1_L
	END_ACTION
	ACTION_QSEC	(when) + 3 * delta
	ROTATE	RIGHT
	TUBE_VALUE	TUBE_1, AUTO, MINUTES_H
	TUBE_VALUE	TUBE_1_ALT, AUTO, MINUTES_1_H
	END_ACTION	
	ACTION_QSEC	(when) + 4 * delta
	ROTATE	RIGHT
	TUBE_VALUE	TUBE_1, AUTO, HOURS_L
	TUBE_VALUE	TUBE_1_ALT, AUTO, HOURS_1_L
	END_ACTION
	ACTION_QSEC	(when) + 5 * delta
	ROTATE	RIGHT
	TUBE_VALUE	TUBE_1, AUTO, HOURS_H
	TUBE_VALUE	TUBE_1_ALT, AUTO, HOURS_1_H
	END_ACTION
#endif
	ENDM
	

;
; Shift time from the right (duration = N_TUBES * delta)
;	
SHIFT_TIME_RIGHT MACRO when, delta
#if NUM_TUBES == 4
	ACTION_QSEC	(when)
	TUBE_VALUE	TUBE_4, AUTO, HOURS_H
	TUBE_VALUE	TUBE_4_ALT, AUTO, HOURS_1_H
	END_ACTION
	ACTION_QSEC	(when) + delta
	ROTATE	LEFT
	TUBE_VALUE	TUBE_4, AUTO, HOURS_L
	TUBE_VALUE	TUBE_4_ALT, AUTO, HOURS_1_L
	END_ACTION
	ACTION_QSEC	(when) + 2 * delta
	ROTATE	LEFT
	TUBE_VALUE	TUBE_4, AUTO, MINUTES_H
	TUBE_VALUE	TUBE_4_ALT, AUTO, MINUTES_1_H
	END_ACTION
	ACTION_QSEC	(when) + 3 * delta
	ROTATE	LEFT
	TUBE_VALUE	TUBE_4, AUTO, MINUTES_L
	TUBE_VALUE	TUBE_4_ALT, AUTO, MINUTES_1_L
	END_ACTION
#else
	ACTION_QSEC	(when)
	TUBE_VALUE	TUBE_6, AUTO, HOURS_H
	TUBE_VALUE	TUBE_6_ALT, AUTO, HOURS_1_H
	END_ACTION
	ACTION_QSEC	(when) + delta
	ROTATE	LEFT
	TUBE_VALUE	TUBE_6, AUTO, HOURS_L
	TUBE_VALUE	TUBE_6_ALT, AUTO, HOURS_1_L
	END_ACTION
	ACTION_QSEC	(when) + 2 * delta
	ROTATE	LEFT
	TUBE_VALUE	TUBE_6, AUTO, MINUTES_H
	TUBE_VALUE	TUBE_6_ALT, AUTO, MINUTES_1_H
	END_ACTION
	ACTION_QSEC	(when) + 3 * delta
	ROTATE	LEFT
	TUBE_VALUE	TUBE_6, AUTO, MINUTES_L
	TUBE_VALUE	TUBE_6_ALT, AUTO, MINUTES_1_L
	END_ACTION
	ACTION_QSEC	(when) + 4 * delta
	ROTATE	LEFT
	TUBE_VALUE	TUBE_6, AUTO, SECONDS_H
	TUBE_VALUE	TUBE_6_ALT, AUTO, SECONDS_1_H
	END_ACTION
	ACTION_QSEC	(when) + 5 * delta
	ROTATE	LEFT
	TUBE_VALUE	TUBE_6, AUTO, SECONDS_L
	TUBE_VALUE	TUBE_6_ALT, AUTO, SECONDS_1_L
	END_ACTION	
#endif
	ENDM
	
	

;
; Shift date from the left (duration = N_TUBES * delta)
;
SHIFT_DATE_LEFT MACRO when, delta
#if NUM_TUBES == 4
	ACTION_QSEC	(when)
	ROTATE	RIGHT
	TUBE_VALUE	TUBE_1, AUTO, DATE_PART2_L
	TUBE_VALUE	TUBE_1_ALT, AUTO, DATE_PART2_1_L
	END_ACTION
	ACTION_QSEC	(when) + delta
	ROTATE	RIGHT
	TUBE_VALUE	TUBE_1, AUTO, DATE_PART2_H
	TUBE_VALUE	TUBE_1_ALT, AUTO, DATE_PART2_1_H
	END_ACTION	
	ACTION_QSEC	(when) + 2 * delta
	ROTATE	RIGHT
	TUBE_VALUE	TUBE_1, AUTO, DATE_PART1_L
	TUBE_VALUE	TUBE_1_ALT, AUTO, DATE_PART1_1_L
	END_ACTION
	ACTION_QSEC	(when) + 3 * delta
	ROTATE	RIGHT
	TUBE_VALUE	TUBE_1, AUTO, DATE_PART1_H
	TUBE_VALUE	TUBE_1_ALT, AUTO, DATE_PART1_1_H
	END_ACTION
#else
	ACTION_QSEC	(when)
	TUBE_VALUE	TUBE_1, AUTO, YEAR_L
	TUBE_VALUE	TUBE_1_ALT, AUTO, YEAR_1_L
	END_ACTION
	ACTION_QSEC	(when) + delta
	ROTATE	RIGHT
	TUBE_VALUE	TUBE_1, AUTO, YEAR_H
	TUBE_VALUE	TUBE_1_ALT, AUTO, YEAR_1_H
	END_ACTION
	ACTION_QSEC	(when) + 2 * delta
	ROTATE	RIGHT
	TUBE_VALUE	TUBE_1, AUTO, DATE_PART2_L
	TUBE_VALUE	TUBE_1_ALT, AUTO, DATE_PART2_1_L
	END_ACTION
	ACTION_QSEC	(when) + 3 * delta
	ROTATE	RIGHT
	TUBE_VALUE	TUBE_1, AUTO, DATE_PART2_H
	TUBE_VALUE	TUBE_1_ALT, AUTO, DATE_PART2_1_H
	END_ACTION	
	ACTION_QSEC	(when) + 4 * delta
	ROTATE	RIGHT
	TUBE_VALUE	TUBE_1, AUTO, DATE_PART1_L
	TUBE_VALUE	TUBE_1_ALT, AUTO, DATE_PART1_1_L
	END_ACTION
	ACTION_QSEC	(when) + 5 * delta
	ROTATE	RIGHT
	TUBE_VALUE	TUBE_1, AUTO, DATE_PART1_H
	TUBE_VALUE	TUBE_1_ALT, AUTO, DATE_PART1_1_H
	END_ACTION
#endif
	ENDM
	

;
; Shift date from the right (duration = N_TUBES * delta)
;	
SHIFT_DATE_RIGHT MACRO when, delta
#if NUM_TUBES == 4
	ACTION_QSEC	(when)
	TUBE_VALUE	TUBE_4, AUTO, DATE_PART1_H
	TUBE_VALUE	TUBE_4_ALT, AUTO, DATE_PART1_1_H
	END_ACTION
	ACTION_QSEC	(when) + delta
	ROTATE	LEFT
	TUBE_VALUE	TUBE_4, AUTO, DATE_PART1_L
	TUBE_VALUE	TUBE_4_ALT, AUTO, DATE_PART1_1_L
	END_ACTION
	ACTION_QSEC	(when) + 2 * delta
	ROTATE	LEFT
	TUBE_VALUE	TUBE_4, AUTO, DATE_PART2_H
	TUBE_VALUE	TUBE_4_ALT, AUTO, DATE_PART2_1_H
	END_ACTION
	ACTION_QSEC	(when) + 3 * delta
	ROTATE	LEFT
	TUBE_VALUE	TUBE_4, AUTO, DATE_PART2_L
	TUBE_VALUE	TUBE_4_ALT, AUTO, DATE_PART2_1_L
	END_ACTION
#else
	ACTION_QSEC	(when)
	TUBE_VALUE	TUBE_6, AUTO, DATE_PART1_H
	TUBE_VALUE	TUBE_6_ALT, AUTO, DATE_PART1_1_H
	END_ACTION
	ACTION_QSEC	(when) + delta
	ROTATE	LEFT
	TUBE_VALUE	TUBE_6, AUTO, DATE_PART1_L
	TUBE_VALUE	TUBE_6_ALT, AUTO, DATE_PART1_1_L
	END_ACTION
	ACTION_QSEC	(when) + 2 * delta
	ROTATE	LEFT
	TUBE_VALUE	TUBE_6, AUTO, DATE_PART2_H
	TUBE_VALUE	TUBE_6_ALT, AUTO, DATE_PART2_1_H
	END_ACTION
	ACTION_QSEC	(when) + 3 * delta
	ROTATE	LEFT
	TUBE_VALUE	TUBE_6, AUTO, DATE_PART2_L
	TUBE_VALUE	TUBE_6_ALT, AUTO, DATE_PART2_1_L
	END_ACTION
	ACTION_QSEC	(when) + 4 * delta
	ROTATE	LEFT
	TUBE_VALUE	TUBE_6, AUTO, YEAR_H
	TUBE_VALUE	TUBE_6_ALT, AUTO, YEAR_1_H
	END_ACTION
	ACTION_QSEC	(when) + 5 * delta
	ROTATE	LEFT
	TUBE_VALUE	TUBE_6, AUTO, YEAR_L
	TUBE_VALUE	TUBE_6_ALT, AUTO, YEAR_1_L
	END_ACTION	
#endif
	ENDM
		
	
;
; Set auto-increment from left to right (fading gets disabled)
;
INCREMENT_LEFT MACRO when, delta, speed
	if (delta) == 0
		ACTION_QSEC	(when)
		TUBE_FADING	TUBE_ALL, FADING, NO_FADING
		TUBE_VALUE	TUBE_ALL, INCREMENT, speed
		END_ACTION
	else
		ACTION_QSEC (when)
		TUBE_FADING	TUBE_11, FADING, NO_FADING
		TUBE_VALUE	TUBE_11, INCREMENT, speed
		END_ACTION
		ACTION_QSEC (when) + delta
		TUBE_FADING	TUBE_22, FADING, NO_FADING
		TUBE_VALUE	TUBE_22, INCREMENT, speed
		END_ACTION
		ACTION_QSEC (when) + 2 * delta
		TUBE_FADING	TUBE_33, FADING, NO_FADING
		TUBE_VALUE	TUBE_33, INCREMENT, speed
		END_ACTION
		ACTION_QSEC (when) + 3 * delta
		TUBE_FADING	TUBE_44, FADING, NO_FADING
		TUBE_VALUE	TUBE_44, INCREMENT, speed
		END_ACTION
#if NUM_TUBES == 6
		ACTION_QSEC (when) + 4 * delta
		TUBE_FADING	TUBE_55, FADING, NO_FADING
		TUBE_VALUE	TUBE_55, INCREMENT, speed
		END_ACTION
		ACTION_QSEC (when) + 5 * delta
		TUBE_FADING	TUBE_66, FADING, NO_FADING
		TUBE_VALUE	TUBE_66, INCREMENT, speed
		END_ACTION
#endif
	endif
	ENDM


;
; Set auto-increment from right to left (fading gets disabled)
; 
INCREMENT_RIGHT MACRO when, delta, speed
	if (delta) == 0
		ACTION_QSEC	(when)
		TUBE_FADING	TUBE_ALL, FADING, NO_FADING
		TUBE_VALUE	TUBE_ALL, INCREMENT, speed
		END_ACTION
	else
#if NUM_TUBES == 4
		ACTION_QSEC (when)
		TUBE_FADING	TUBE_44, FADING, NO_FADING
		TUBE_VALUE	TUBE_44, INCREMENT, speed
		END_ACTION
		ACTION_QSEC (when) + delta
		TUBE_FADING	TUBE_33, FADING, NO_FADING
		TUBE_VALUE	TUBE_33, INCREMENT, speed
		END_ACTION
		ACTION_QSEC (when) + 2 * delta
		TUBE_FADING	TUBE_22, FADING, NO_FADING
		TUBE_VALUE	TUBE_22, INCREMENT, speed
		END_ACTION
		ACTION_QSEC (when) + 3 * delta
		TUBE_FADING	TUBE_11, FADING, NO_FADING
		TUBE_VALUE	TUBE_11, INCREMENT, speed
		END_ACTION
#else
		ACTION_QSEC (when)
		TUBE_FADING	TUBE_66, FADING, NO_FADING
		TUBE_VALUE	TUBE_66, INCREMENT, speed
		END_ACTION
		ACTION_QSEC (when) + delta
		TUBE_FADING	TUBE_55, FADING, NO_FADING
		TUBE_VALUE	TUBE_55, INCREMENT, speed
		END_ACTION
		ACTION_QSEC (when) + 2 * delta
		TUBE_FADING	TUBE_44, FADING, NO_FADING
		TUBE_VALUE	TUBE_44, INCREMENT, speed
		END_ACTION
		ACTION_QSEC (when) + 3 * delta
		TUBE_FADING	TUBE_33, FADING, NO_FADING
		TUBE_VALUE	TUBE_33, INCREMENT, speed
		END_ACTION
		ACTION_QSEC (when) + 4 * delta
		TUBE_FADING	TUBE_22, FADING, NO_FADING
		TUBE_VALUE	TUBE_22, INCREMENT, speed
		END_ACTION
		ACTION_QSEC (when) + 5 * delta
		TUBE_FADING	TUBE_11, FADING, NO_FADING
		TUBE_VALUE	TUBE_11, INCREMENT, speed
		END_ACTION	
#endif
	endif
	ENDM
	
	
	
;
; Transition to date (increment pairs one by one)
;
TO_DATE_WITH_INCREMENT MACRO when, delta, speed
	ACTION_QSEC	(when)
	TUBE_FADING	TUBE_1 | TUBE_2, FADING, NO_FADING
	TUBE_VALUE	TUBE_1 | TUBE_2, INCREMENT, speed
	END_ACTION
	ACTION_QSEC	(when) + delta
	M_DA1		1, 0
	M_DA1_ALT	1, 1
	TUBE_FADING	TUBE_3 | TUBE_4, FADING, NO_FADING
	TUBE_VALUE	TUBE_3 | TUBE_4, INCREMENT, speed
	END_ACTION
	ACTION_QSEC	(when) + 2 * delta
	M_DA2		2, 0
	M_DA2_ALT	2, 1
#if NUM_TUBES == 6
	TUBE_FADING	TUBE_5 | TUBE_6, FADING, NO_FADING
	TUBE_VALUE	TUBE_5 | TUBE_6, INCREMENT, speed
	END_ACTION
	ACTION_QSEC	(when) + 3 * delta
	M_YY		3, 0
	M_YY_ALT	3, 1
#endif
	END_ACTION
	ENDM


;
; Transition to time (increment pairs one by one)
;
TO_TIME_WITH_INCREMENT MACRO when, delta, speed
	ACTION_QSEC	(when)
	TUBE_FADING	TUBE_1 | TUBE_2, FADING, NO_FADING
	TUBE_VALUE	TUBE_1 | TUBE_2, INCREMENT, speed
	END_ACTION
	ACTION_QSEC	(when) + delta
	M_HH		1, 0
	M_HH_ALT	1, 1
	TUBE_FADING	TUBE_3 | TUBE_4, FADING, NO_FADING
	TUBE_VALUE	TUBE_3 | TUBE_4, INCREMENT, speed
	END_ACTION
	ACTION_QSEC	(when) + 2 * delta
	M_MM		2, 0
	M_MM_ALT	2, 1
#if NUM_TUBES == 6
	TUBE_FADING	TUBE_5 | TUBE_6, FADING, NO_FADING
	TUBE_VALUE	TUBE_5 | TUBE_6, INCREMENT, speed
	END_ACTION
	ACTION_QSEC	(when) + 3 * delta
	M_SS		3, 0
	M_SS_ALT	3, 1
#endif
	END_ACTION
	ENDM



;
; Set date, one tube at a time
;
TO_DATE_1_BY_1 MACRO when, delta
	ACTION_QSEC	(when)
	TUBE_VALUE	TUBE_1,     AUTO, DATE_PART1_H
	TUBE_VALUE	TUBE_1_ALT, AUTO, DATE_PART1_1_H
	END_ACTION
	ACTION_QSEC	(when) + delta
	TUBE_VALUE	TUBE_2,     AUTO, DATE_PART1_L
	TUBE_VALUE	TUBE_2_ALT, AUTO, DATE_PART1_1_L
	END_ACTION
	ACTION_QSEC	(when) + 2 * delta
	TUBE_VALUE	TUBE_3,     AUTO, DATE_PART2_H
	TUBE_VALUE	TUBE_3_ALT, AUTO, DATE_PART2_1_H
	END_ACTION
	ACTION_QSEC	(when) + 3 * delta
	TUBE_VALUE	TUBE_4,     AUTO, DATE_PART2_L
	TUBE_VALUE	TUBE_4_ALT, AUTO, DATE_PART2_1_L
	END_ACTION
#if NUM_TUBES == 6
	ACTION_QSEC	(when) + 4 * delta
	TUBE_VALUE	TUBE_5,     AUTO, YEAR_H
	TUBE_VALUE	TUBE_5_ALT, AUTO, YEAR_1_H
	END_ACTION
	ACTION_QSEC	(when) + 5 * delta
	TUBE_VALUE	TUBE_6,     AUTO, YEAR_L
	TUBE_VALUE	TUBE_6_ALT, AUTO, YEAR_1_L
	END_ACTION
#endif
	ENDM

;
; Set time, one tube at a time
;
TO_TIME_1_BY_1 MACRO when, delta
	ACTION_QSEC	(when)
	TUBE_VALUE	TUBE_1,     AUTO, HOURS_H
	TUBE_VALUE	TUBE_1_ALT, AUTO, HOURS_1_H
	END_ACTION
	ACTION_QSEC	(when) + delta
	TUBE_VALUE	TUBE_2,     AUTO, HOURS_L
	TUBE_VALUE	TUBE_2_ALT, AUTO, HOURS_1_L
	END_ACTION
	ACTION_QSEC	(when) + 2 * delta
	TUBE_VALUE	TUBE_3,     AUTO, MINUTES_H
	TUBE_VALUE	TUBE_3_ALT, AUTO, MINUTES_1_H
	END_ACTION
	ACTION_QSEC	(when) + 3 * delta
	TUBE_VALUE	TUBE_4,     AUTO, MINUTES_L
	TUBE_VALUE	TUBE_4_ALT, AUTO, MINUTES_1_L
	END_ACTION
#if NUM_TUBES == 6
	ACTION_QSEC	(when) + 4 * delta
	TUBE_VALUE	TUBE_5,     AUTO, SECONDS_H
	TUBE_VALUE	TUBE_5_ALT, AUTO, SECONDS_1_H
	END_ACTION
	ACTION_QSEC	(when) + 5 * delta
	TUBE_VALUE	TUBE_6,     AUTO, SECONDS_L
	TUBE_VALUE	TUBE_6_ALT, AUTO, SECONDS_1_L
	END_ACTION
#endif
	ENDM

;
; Shift in 'what' to position 'pos', from left to right
;
; Typically, use this when the display is empty, and shift in data one by one.
;
SHIFT_DATA_LR MACRO what, alt, pos, when, delta
		ACTION_QSEC	(when)
		TUBE_VALUE	TUBE_1, AUTO, what
		TUBE_VALUE	TUBE_1_ALT, AUTO, alt
		END_ACTION
	if pos > 1
		ACTION_QSEC	(when) + delta
		TUBE_VALUE	TUBE_11, DIRECT, 0xF
		TUBE_VALUE	TUBE_2, AUTO, what
		TUBE_VALUE	TUBE_2_ALT, AUTO, alt
		END_ACTION
	endif
	if pos > 2
		ACTION_QSEC	(when) + 2 * delta
		TUBE_VALUE	TUBE_22, DIRECT, 0xF
		TUBE_VALUE	TUBE_3, AUTO, what
		TUBE_VALUE	TUBE_3_ALT, AUTO, alt
		END_ACTION
	endif
	if pos > 3
		ACTION_QSEC	(when) + 3 * delta
		TUBE_VALUE	TUBE_33, DIRECT, 0xF
		TUBE_VALUE	TUBE_4, AUTO, what
		TUBE_VALUE	TUBE_4_ALT, AUTO, alt
		END_ACTION
	endif
	if pos > 4
		ACTION_QSEC	(when) + 4 * delta
		TUBE_VALUE	TUBE_44, DIRECT, 0xF
		TUBE_VALUE	TUBE_5, AUTO, what
		TUBE_VALUE	TUBE_5_ALT, AUTO, alt
		END_ACTION
	endif
	if pos > 5
		ACTION_QSEC	(when) + 5 * delta
		TUBE_VALUE	TUBE_55, DIRECT, 0xF
		TUBE_VALUE	TUBE_6, AUTO, what
		TUBE_VALUE	TUBE_6_ALT, AUTO, alt
		END_ACTION
	endif
	ENDM
	
	
;
; Shift in 'what' to position 'pos', from right to left
;
; Typically, use this when the display is empty, and shift in data one by one.
;
SHIFT_DATA_RL MACRO what, alt, pos, when, delta
		ACTION_QSEC	(when)
		TUBE_VALUE	TUBE_6, AUTO, what
		TUBE_VALUE	TUBE_6_ALT, AUTO, alt
		END_ACTION
	if pos < 6
		ACTION_QSEC	(when) + delta
		TUBE_VALUE	TUBE_66, DIRECT, 0xF
		TUBE_VALUE	TUBE_5, AUTO, what
		TUBE_VALUE	TUBE_5_ALT, AUTO, alt
		END_ACTION
	endif
	if pos < 5
		ACTION_QSEC	(when) + 2 * delta
		TUBE_VALUE	TUBE_55, DIRECT, 0xF
		TUBE_VALUE	TUBE_4, AUTO, what
		TUBE_VALUE	TUBE_4_ALT, AUTO, alt
		END_ACTION
	endif
	if pos < 4
		ACTION_QSEC	(when) + 3 * delta
		TUBE_VALUE	TUBE_44, DIRECT, 0xF
		TUBE_VALUE	TUBE_3, AUTO, what
		TUBE_VALUE	TUBE_3_ALT, AUTO, alt
		END_ACTION
	endif
	if pos < 3
		ACTION_QSEC	(when) + 4 * delta
		TUBE_VALUE	TUBE_33, DIRECT, 0xF
		TUBE_VALUE	TUBE_2, AUTO, what
		TUBE_VALUE	TUBE_2_ALT, AUTO, alt
		END_ACTION
	endif
	if pos < 2
		ACTION_QSEC	(when) + 5 * delta
		TUBE_VALUE	TUBE_22, DIRECT, 0xF
		TUBE_VALUE	TUBE_1, AUTO, what
		TUBE_VALUE	TUBE_1_ALT, AUTO, alt
		END_ACTION
	endif
	ENDM
	

;
; Shift in HHMMSS
;
SHIFT_TIME_RIGHT_1_BY_1 MACRO when, delta
	SHIFT_DATA_LR	SECONDS_L, SECONDS_1_L, 6, when              , delta
	SHIFT_DATA_LR	SECONDS_H, SECONDS_1_H, 5, when +  .6 * delta, delta
	SHIFT_DATA_LR	MINUTES_L, MINUTES_1_L, 4, when + .11 * delta, delta
	SHIFT_DATA_LR	MINUTES_H, MINUTES_1_H, 3, when + .15 * delta, delta
	SHIFT_DATA_LR	HOURS_L,   HOURS_1_L,   2, when + .18 * delta, delta
	SHIFT_DATA_LR	HOURS_H,   HOURS_1_H,   1, when + .20 * delta, delta
	ENDM
	
SHIFT_TIME_LEFT_1_BY_1 MACRO when, delta
	SHIFT_DATA_RL	HOURS_H,   HOURS_1_H,   1, when              , delta
	SHIFT_DATA_RL	HOURS_L,   HOURS_1_L,   2, when +  .6 * delta, delta
	SHIFT_DATA_RL	MINUTES_H, MINUTES_1_H, 3, when + .11 * delta, delta
	SHIFT_DATA_RL	MINUTES_L, MINUTES_1_L, 4, when + .15 * delta, delta
	SHIFT_DATA_RL	SECONDS_H, SECONDS_1_H, 5, when + .18 * delta, delta
	SHIFT_DATA_RL	SECONDS_L, SECONDS_1_L, 6, when + .20 * delta, delta
	ENDM
	
;
; Shift in date (doesn't work with DATE_PART<x> because the SHIFT_DATA
; macro used an offset to compute the ALT value)
;
SHIFT_DATE_RIGHT_1_BY_1 MACRO when, delta
	SHIFT_DATA_LR	YEAR_L,  YEAR_1_L,  6, when              , delta
	SHIFT_DATA_LR	YEAR_H,  YEAR_1_H,  5, when +  .6 * delta, delta
	SHIFT_DATA_LR	MONTH_L, MONTH_1_L, 4, when + .11 * delta, delta
	SHIFT_DATA_LR	MONTH_H, MONTH_1_H, 3, when + .15 * delta, delta
	SHIFT_DATA_LR	DAY_L,   DAY_1_L,   2, when + .18 * delta, delta
	SHIFT_DATA_LR	DAY_H,   DAY_1_H,   1, when + .20 * delta, delta
	ENDM

SHIFT_DATE_LEFT_1_BY_1 MACRO when, delta
	SHIFT_DATA_RL	DAY_H,   DAY_1_H,   1, when              , delta
	SHIFT_DATA_RL	DAY_L,   DAY_1_L,   2, when +  .6 * delta, delta
	SHIFT_DATA_RL	MONTH_H, MONTH_1_H, 3, when + .11 * delta, delta
	SHIFT_DATA_RL	MONTH_L, MONTH_1_L, 4, when + .15 * delta, delta
	SHIFT_DATA_RL	YEAR_H,  YEAR_1_H,  5, when + .18 * delta, delta
	SHIFT_DATA_RL	YEAR_L,  YEAR_1_L,  6, when + .20 * delta, delta
	ENDM