;;;
;;; Copyright (C) 2010 Frederic Vecoven
;;;
;;; This file is part of NixieClock
;;;
;;; NixieClock is free software; you can redistribute it and/or modify
;;; it under the terms of the GNU General Public License as published by
;;; the Free Software Foundation; either version 3 of the License, or
;;; (at your option) any later version.
;;;
;;; NixieClock is distributed in the hope that it will be useful,
;;; but WITHOUT ANY WARRANTY; without even the implied warranty of
;;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;; GNU General Public License for more details.
;;;
;;; You should have received a copy of the GNU General Public License
;;; along with this program. If not, see <http://www.gnu.org/licenses/>.
;;;

; 
; hardware settings
;

;;; ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;; 
;;; clock model 1 is my 4 tubes prototype, with GR-116D tubes
;;;
;;; ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
#if CLOCK_MODEL == 1

	error "CLOCK MODEL 1 is not supported in this branch"

#else

;;; ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;; 
;;; clock model 2 is my 6 tubes prototype. Tubes are IN-8-2.
;;;
;;; PCB made by Olimex. Tubes in front, rev 1.0.
;;;
;;; ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;	
#if CLOCK_MODEL == 2

	error "CLOCK MODEL 2 is not supported in this branch"
	
#else

;;; ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;; 
;;; clock model 3 is my 6 tubes final clock. Tubes are IN-8-2.
;;;
;;; PCB made by Olimex. Tubes in middle, rev 2.00.
;;;
;;; ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;	
#if CLOCK_MODEL == 3

#define NUM_TUBES	6

; need to remap digit
#define REQUIRE_DIGIT_MAPPING	1

; this clock has an IR receiver
#define SUPPORT_IR	0

; full support for the 6 dots
#define HARDWARE_DP	1
#define SUPPORT_DP	0

; VOUT depends on the tubes. 180V for IN-8-2
VOUT	EQU	.185

; pin assignments

#define	PWM_DIR		TRISC,2
#define	PWM_LAT		LATC,2
#define	PWM_PIN		PORTC,2

#define	ANODE0_DIR	TRISB,3
#define	ANODE0		LATB,3
#define	ANODE0_PIN	PORTB,3

#define	ANODE1_DIR	TRISA,3
#define	ANODE1		LATA,3
#define	ANODE1_PIN	PORTA,3

#define ANODE2_DIR	TRISA,2
#define ANODE2		LATA,2
#define ANODE2_PIN	PORTA,2

#define	POWER_DIR	TRISB,0
#define	POWER_PIN	PORTB,0

#define BUTTON0_DIR	TRISC,3
#define BUTTON0_PIN	PORTC,3

#define BUTTON1_DIR	TRISA,6
#define BUTTON1_PIN	PORTA,6

#define DP0_DIR		TRISA,4
#define DP0		LATA,4
#define DP0_PIN		PORTA,4

#define DP1_DIR		TRISA,5
#define DP1		LATA,5
#define DP1_PIN		PORTA,5

#define LATB_C_BIT	6
#define LATB_D_BIT	7
#define LATC_C_BIT	6
#define LATC_D_BIT	7

#define IR_DIR		TRISB,1
#define IR_PIN		PORTB,1
#define IR_EDGE_REG	INTCON2
#define IR_EDGE_BIT	INTEDG1
#define IR_INT_IE	INTCON3,INT1IE
#define IR_INT_IP	INTCON3,INT1IP
#define IR_INT_IF	INTCON3,INT1IF

#define EXT2_DIR	TRISB,2
#define EXT2_PIN	PORTB,2
#define EXT2		LATB,2

#define EXT3_DIR	TRISA,7
#define EXT3_PIN	PORTA,7
#define EXT3		LATA,7

#define EXT4_DIR	TRISA,1
#define EXT4_PIN	PORTA,1
#define EXT4		LATA,1

#else
	error "Invalid CLOCK MODEL"

#endif
#endif
#endif
