;;;
;;; Copyright (C) 2010 Frederic Vecoven
;;;
;;; This file is part of NixieClock
;;;
;;; NixieClock is free software; you can redistribute it and/or modify
;;; it under the terms of the GNU General Public License as published by
;;; the Free Software Foundation; either version 3 of the License, or
;;; (at your option) any later version.
;;;
;;; NixieClock is distributed in the hope that it will be useful,
;;; but WITHOUT ANY WARRANTY; without even the implied warranty of
;;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;; GNU General Public License for more details.
;;;
;;; You should have received a copy of the GNU General Public License
;;; along with this program. If not, see <http://www.gnu.org/licenses/>.
;;;
	
;
; math routines
;
	include hv.inc
	
	; variables
	extern	rand,d1,d2,dec
	
	
math_code	CODE
	
; 
; initialize random generator
;
init_random
	GLOBAL	init_random
	movff	TMR1H,rand+1
	movff	TMR1L,rand
	bz	ir_0
	return
ir_0	movlw	0xA6
	movwf	rand
	return
	
; 
; random generator : LFSR (16 bits)
; polynom is 0xA1A1
;
random
	GLOBAL	random
	bcf	STATUS,C
	rrcf	rand+1,f
	rrcf	rand,f
	btfss	STATUS,C
	return
	movlw	0xA1
	xorwf	rand+1,f
	xorwf	rand,f
	movf	rand,w
	return
	

; generate a random number between 0 and 9	
rand_10
	GLOBAL	rand_10
	call	random
	andlw	0x0F		; 0 <= W < 16
	movwf	d1
	movlw	0xA
	subwf	d1,w
	btfsc	STATUS,C
	movwf	d1
	movf	d1,w
	return


; generate a random number between 0 and W, W max being 0xF.
rand_W_16
	GLOBAL	rand_W_16
	bz	ret0		; if 0, return 0.
	movwf	d1		; d1 = max random value
	call	random
	andlw	0x0F		; 0 <= W < 16
rw16	cpfslt	d1		; while (max < rand)
	return
	bsf	STATUS,C
	subfwb	d1,w		; 	rand -= max
	bra	rw16
ret0	retlw	.0


; binary (W) to decimal (dec+2 = hundreds  dec+1 = tens  dec+0 = ones)
bin2dec
	GLOBAL	bin2dec
	movwf	d1
	movlw	.8
	movwf	d2
	clrf	dec+2
	clrf	dec+1
	clrf	dec+0
bcdadd3
	movlw	.5
	subwf	dec+2,w
	btfsc	STATUS,C
	call	add3huns
	movlw	.5
	subwf	dec+1,w
	btfsc	STATUS,C
	call	add3tens
	movlw	.5
	subwf	dec+0,w
	btfsc	STATUS,C
	call	add3ones
	decf	d2,f
	bcf	STATUS,C
	rlcf	d1,f
	rlcf	dec+0,f
	btfsc	dec+0,4
	call	carryOnes
	rlcf	dec+1,f
	btfsc	dec+1,4
	call	carryTens
	rlcf	dec+2,f
	bcf	STATUS,C
	movf	d2,w
	bnz	bcdadd3
	return
add3huns
	movlw	.3
	addwf	dec+2,f
	return
add3tens
	movlw	.3
	addwf	dec+1,f
	return
add3ones
	movlw	.3
	addwf	dec+0,f
	return
carryOnes
	bcf	dec+0,4
	bsf	STATUS,C
	return
carryTens
	bcf	dec+1,4
	bsf	STATUS,C
	return

	
	END
	
