;;;
;;; Copyright (C) 2010 Frederic Vecoven
;;;
;;; This file is part of NixieClock
;;;
;;; NixieClock is free software; you can redistribute it and/or modify
;;; it under the terms of the GNU General Public License as published by
;;; the Free Software Foundation; either version 3 of the License, or
;;; (at your option) any later version.
;;;
;;; NixieClock is distributed in the hope that it will be useful,
;;; but WITHOUT ANY WARRANTY; without even the implied warranty of
;;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;; GNU General Public License for more details.
;;;
;;; You should have received a copy of the GNU General Public License
;;; along with this program. If not, see <http://www.gnu.org/licenses/>.
;;;
	
;
; Clock animation program
;
	include hv.inc
	include program.inc
	include effects.inc

	
clock_prog_code	CODE_PACK

;;; day of week. 0=Sunday. Remember to keep entries sorted !
day_prog
	GLOBAL	day_prog
	ACTION		SUNDAY
	HOUR_PTR	hour_prog_0
	END_ACTION
    END_PROGRAM
	

hour_prog_0
	ACTION		.0
	MINUTE_PTR	minute_prog_0
	END_ACTION
    END_PROGRAM


minute_prog_0
	ACTION		.0
#if 1
	QSEC_PTR	qsec_prog_0
	MINUTE_PTR	minute_prog_0		; loop
#else
	QSEC_PTR	q_all_secs
#endif
	END_ACTION
    END_PROGRAM


qsec_prog_0
	ACTION		.0
	GOSUB		sub_time
	QSEC_PTR	q_to_date_random
	END_ACTION
    END_PROGRAM


;;;
;;; all digits are second (testing)
;;;
q_all_secs
	ACTION_QSEC	.0
	TUBE_BRIGHT	TUBE_ALL, DIRECT, 0xA
	GOSUB		sub_multi_fading_L
	TUBE_VALUE	TUBE_123456,     AUTO, SECONDS_L
	TUBE_VALUE	TUBE_123456_ALT, AUTO, SECONDS_1_L
	END_ACTION
    END_PROGRAM

;;;
;;; select a random date transition
;;;
q_to_date_random
	ACTION_QSEC2	.30, .1
#if 0
	QSEC_PTR to_date_12
#else
	QSEC_RAND_PTR	.11
		PROG to_date_1
		PROG to_date_2
		PROG to_date_3
		PROG to_date_4
		PROG to_date_5
		PROG to_date_6
		PROG to_date_7
		PROG to_date_8
		PROG to_date_9
		PROG to_date_10
		PROG to_date_11
		;PROG to_date_12
#endif
	END_ACTION
    END_PROGRAM


;;;
;;; select a random time transition
;;;
q_to_time_random
	ACTION_QSEC2	.48, .1
#if 0
	QSEC_PTR to_time_5
#else
	QSEC_RAND_PTR	.6
		PROG to_time_1
		PROG to_time_2
		PROG to_time_3
		PROG to_time_5
		PROG to_time_5
		PROG to_time_6
#endif
	END_ACTION
    END_PROGRAM
	

;;;
;;; show date at xx:xx:40 with various effects
;;;
to_date_1
	EMPTY_LEFT		.2448, .16
	SHIFT_DATE_LEFT 	.2560, .16
	ACTION_QSEC		.2656
	QSEC_PTR		q_to_time_random
    	END_ACTION
    END_PROGRAM
	
to_date_2
	EMPTY_LEFT		.2352, .32
	SHIFT_DATE_LEFT		.2560, .32
	ACTION_QSEC		.2752
	QSEC_PTR		q_to_time_random
    	END_ACTION
    END_PROGRAM
	
to_date_3
	EMPTY_RIGHT	 	.2448, .16
	SHIFT_DATE_RIGHT 	.2560, .16
	ACTION_QSEC		.2656
	QSEC_PTR	 	q_to_time_random
    	END_ACTION
    END_PROGRAM
	
to_date_4
	EMPTY_RIGHT	 	.2353, .32
	SHIFT_DATE_RIGHT 	.2560, .32
	ACTION_QSEC		.2752
	QSEC_PTR	 	q_to_time_random
    	END_ACTION
    END_PROGRAM	

to_date_5
	ACTION_QSEC		.2496
	GOSUB 			sub_multi_fading_L
	DDMMYY			.1, .0
	END_ACTION
	ACTION_QSEC		.2560
	DDMMYY			.0, .0
	DDMMYY			.1, .1
	QSEC_PTR		q_to_time_random
    	END_ACTION
    END_PROGRAM
	
to_date_6
	ACTION_QSEC		.2496
	GOSUB			sub_multi_fading_R
	DDMMYY			.1, .0
	END_ACTION
	ACTION_QSEC		.2560
	DDMMYY			.0, .0
	DDMMYY			.1, .1
	QSEC_PTR		q_to_time_random
    	END_ACTION
    END_PROGRAM
	
to_date_7
	TO_DATE_WITH_INCREMENT	.2560, .96, EVERY_1_32_S
	ACTION_QSEC		.2848
	QSEC_PTR		q_to_time_random
	END_ACTION
    END_PROGRAM

to_date_8
	INCREMENT_LEFT		.2240, .64, EVERY_1_16_S
	TO_DATE_1_BY_1		.2560, .64
	ACTION_QSEC		.2944
	QSEC_PTR		q_to_time_random
	END_ACTION
    END_PROGRAM
    
to_date_9
	EMPTY_LEFT		.2240, .16
	SHIFT_DATE_RIGHT_1_BY_1	.2400, .16
	ACTION_QSEC		.2784
	QSEC_PTR		q_to_time_random
	END_ACTION
    END_PROGRAM	

to_date_10
	ACTION_QSEC		.2496
	GOSUB			sub_multi_fading_L
	DDMMYY			.1, .0
	END_ACTION
	ACTION_QSEC		.2560
	DDMMYY			.0, .0
	DDMMYY			.1, .1
	QSEC_PTR		q_to_time_random
	END_ACTION
    END_PROGRAM
    
to_date_11
	ACTION_QSEC		.2496
	GOSUB			sub_multi_fading_R
	DDMMYY			.1, .0
	END_ACTION
	ACTION_QSEC		.2560
	DDMMYY			.0, .0
	DDMMYY			.1, .1
	QSEC_PTR		q_to_time_random
	END_ACTION
    END_PROGRAM
   
#if 0 
to_date_12
	EMPTY_RIGHT		.2240, .16
	ACTION_QSEC		.2399
	TUBE_FADING		TUBE_ALL, FADING, 0x5
	END_ACTION
	SHIFT_DATE_LEFT_1_BY_1	.2400, .8
	ACTION_QSEC		.2784
	QSEC_PTR		q_to_time_random
	END_ACTION
    END_PROGRAM
#endif

;;;
;;; show time at xx:xx:50 with various effects
;;;
to_time_1
	ACTION_QSEC		.3136
	GOSUB			sub_multi_fading_L
	HHMMSS			.1, .0
	END_ACTION
	ACTION_QSEC		.3200
	GOSUB			sub_time
	END_ACTION
    END_PROGRAM
    
to_time_2
	ACTION_QSEC		.3136
	GOSUB			sub_multi_fading_R
	HHMMSS			.1, .0
	END_ACTION
	ACTION_QSEC		.3200
	GOSUB			sub_time
	END_ACTION	
    END_PROGRAM	

to_time_3
	TO_TIME_WITH_INCREMENT	.3136, .96, EVERY_1_32_S
	ACTION_QSEC		.3424
	GOSUB			sub_time
	END_ACTION
    END_PROGRAM

to_time_4
	EMPTY_RIGHT		.3136, .16
	ACTION_QSEC		.3264
	GOSUB			sub_multi_fading_L
	END_ACTION
	SHIFT_TIME_RIGHT_1_BY_1	.3264, .16
	ACTION_QSEC		.3584
	GOSUB			sub_time
	END_ACTION
    END_PROGRAM
    
to_time_5
	EMPTY_RIGHT		.3136, .16
	ACTION_QSEC		.3264
	GOSUB			sub_multi_fading_L
	END_ACTION
	SHIFT_TIME_RIGHT_1_BY_1	.3264, .6
	ACTION_QSEC		.3584
	GOSUB			sub_time
	END_ACTION
    END_PROGRAM
    
to_time_6
	EMPTY_RIGHT		.3136, .16
	ACTION_QSEC		.3264
	TUBE_FADING		TUBE_ALL, FADING, 0x5
	END_ACTION
	SHIFT_TIME_LEFT_1_BY_1	.3264, .16
	ACTION_QSEC		.3584
	GOSUB			sub_time
	END_ACTION
    END_PROGRAM


;;;
;;; show time with nice fading
;;;
sub_time
	TUBE_BRIGHT	TUBE_ALL, DIRECT, 0xA
	GOSUB		sub_multi_fading_L
	HHMMSS		.0, .0
	HHMMSS		.1, .1
    END_SUB


;;;
;;; tubes from the left fades slower than the right
;;;
sub_multi_fading_L
	TUBE_FADING	TUBE_1, FADING, 0xF
	TUBE_FADING	TUBE_2, FADING, 0xD
	TUBE_FADING	TUBE_3, FADING, 0xB
	TUBE_FADING	TUBE_4, FADING, 0x9
	TUBE_FADING	TUBE_5, FADING, 0x7
	TUBE_FADING	TUBE_6, FADING, 0x5
    END_SUB
	
;;;
;;; inverse of the above
;;;
sub_multi_fading_R
	TUBE_FADING	TUBE_1, FADING, 0x5
	TUBE_FADING	TUBE_2, FADING, 0x7
	TUBE_FADING	TUBE_3, FADING, 0x9
	TUBE_FADING	TUBE_4, FADING, 0xB
	TUBE_FADING	TUBE_5, FADING, 0xD
	TUBE_FADING	TUBE_6, FADING, 0xF
    END_SUB	


	END
	